//===================================================================
// Apci8284w.pas - wrapper for Delphi 
//-------------------------------------------------------------------
// Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//===================================================================
unit Apci8284w;

interface

uses
  Windows, SysUtils;

const
	APCI8284_SUCCESS							=0;
	APCI8284_ERR_SYSTEM						=1;
	APCI8284_ERR_NO_DEVICE				=2;
	APCI8284_ERR_IN_USE						=3;
	APCI8284_ERR_INVALID_SLOT			=4;
	APCI8284_ERR_RESOURCE					=5;
	APCI8284_ERR_INVALID_ARGUMENT	=6;
	APCI8284_ERR_REGION						=10;
	APCI8284_ERR_OFFSET						=11;
	APCI8284_ERR_MEM_ALLOC				=13;
	APCI8284_ERR_MEM_FREE					=14;
	APCI8284_ERR_MEM_ACCESS				=15;
	APCI8284_ERR_WRAPDLL					=$FFFF;

	APCI8284_SLOT_AUTO						=$FFFF;
	APCI8284_MAX_SLOTS						=16;
	APCI8284_DLL_NAME							='Apci8284.dll';

	APCI8284_MAX_MEM							=6;
	APCI8284_MAX_IO								=6;


type

	APCI8284RESOURCE = record
		dwNumMemRegion:																 DWORD;
		dwMemBase:			Array[1..APCI8284_MAX_MEM]	of DWORD;
		dwMemLength:		Array[1..APCI8284_MAX_MEM]	of DWORD;
		dwNumIoRegion:																 DWORD;
		dwIoBase:				Array[1..APCI8284_MAX_IO]		of DWORD;
		dwIoLength:			Array[1..APCI8284_MAX_IO]		of DWORD;
		dwIrq:																				 DWORD;
	end;
	PAPCI8284R = ^APCI8284RESOURCE;


// function
	function Apci8284wDllOpen: Boolean;
	function Apci8284wDllClose: Boolean;
	function Apci8284wGetVersion( var pdwDllVer:DWORD; var pdwDrvVer:DWORD ):Boolean;
	function Apci8284wCreate( var pwLogSlot:WORD; hWnd:HWND; u_WMBase:UINT ):Boolean;
	function Apci8284wClose( wLogSlot:WORD ):Boolean;
	function Apci8284wGetResource( wLogSlot:WORD; pRes:PAPCI8284R ):Boolean;
	function Apci8284wGetLastError( wLogSlot:WORD ):DWORD;

	function Apci8284wIoReadByte( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; var pbData: BYTE):Boolean;
	function Apci8284wIoReadWord( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; var pwData: WORD):Boolean;
	function Apci8284wIoReadDWord( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; var pdwData: DWORD):Boolean;
	function Apci8284wIoWriteByte( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; bData: BYTE):Boolean;
	function Apci8284wIoWriteWord( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; wData: WORD):Boolean;
	function Apci8284wIoWriteDWord( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; dwData: DWORD):Boolean;
	function Apci8284wMemReadByte( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; var pbData: BYTE):Boolean;
	function Apci8284wMemReadWord( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; var pwData: WORD):Boolean;
	function Apci8284wMemReadDWord( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; var pdwData: DWORD):Boolean;
	function Apci8284wMemWriteByte( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; bData: BYTE):Boolean;
	function Apci8284wMemWriteWord( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; wData: WORD):Boolean;
	function Apci8284wMemWriteDWord( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; dwData: DWORD):Boolean;

	function Apci8284wDmaAlloc( wLogSlot:WORD; dwMemSize:DWORD; var pdwAddress: DWORD):Boolean;
	function Apci8284wDmaRead( wLogSlot:WORD; dwOffset:DWORD; var pbBuff:array of BYTE; dwSize: DWORD ):Boolean;
	function Apci8284wDmaWrite( wLogSlot:WORD; dwOffset:DWORD; var pbBuff:array of BYTE; dwSize: DWORD ):Boolean;
	function Apci8284wDmaFree( wLogSlot:WORD ):Boolean;


implementation

{$J+}	// ^t萔̕ύX\߲׎w

const
	hDLL: THandle = 0;
type
	TApci8284GetVersion 		= function ( var pdwDllVer:DWORD; var pdwDrvVer:DWORD ):Boolean; stdcall;
	TApci8284Create 				= function ( var pwLogSlot:WORD; hWnd:HWND; u_WMBase:UINT ):Boolean; stdcall;
	TApci8284Close 					= function ( wLogSlot:WORD ):Boolean; stdcall;
	TApci8284GetResource 		= function ( wLogSlot:WORD; pRes:PAPCI8284R ):Boolean; stdcall;
	TApci8284GetLastError 	= function ( wLogSlot:WORD ):DWORD; stdcall;

	TApci8284IoReadByte 		= function ( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; var pbData: BYTE):Boolean; stdcall;
	TApci8284IoReadWord 		= function ( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; var pwData: WORD):Boolean; stdcall;
	TApci8284IoReadDWord 		= function ( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; var pdwData: DWORD):Boolean; stdcall;
	TApci8284IoWriteByte 		= function ( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; bData: BYTE):Boolean; stdcall;
	TApci8284IoWriteWord 		= function ( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; wData: WORD):Boolean; stdcall;
	TApci8284IoWriteDWord 	= function ( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; dwData: DWORD):Boolean; stdcall;
	TApci8284MemReadByte 		= function ( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; var pbData: BYTE):Boolean; stdcall;
	TApci8284MemReadWord 		= function ( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; var pwData: WORD):Boolean; stdcall;
	TApci8284MemReadDWord 	= function ( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; var pdwData: DWORD):Boolean; stdcall;
	TApci8284MemWriteByte 	= function ( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; bData: BYTE):Boolean; stdcall;
	TApci8284MemWriteWord 	= function ( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; wData: WORD):Boolean; stdcall;
	TApci8284MemWriteDWord 	= function ( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; dwData: DWORD):Boolean; stdcall;

	TApci8284DmaAlloc				= function ( wLogSlot:WORD; dwMemSize:DWORD; var pdwAddress: DWORD):Boolean; stdcall;
	TApci8284DmaRead        = function ( wLogSlot:WORD; dwOffset:DWORD; pbBuff:PChar; dwSize: DWORD ):Boolean; stdcall;
	TApci8284DmaWrite       = function ( wLogSlot:WORD; dwOffset:DWORD; pbBuff:PChar; dwSize: DWORD ):Boolean; stdcall;
	TApci8284DmaFree        = function ( wLogSlot:WORD ):Boolean; stdcall;


// DLL ߰Ċ֐ڽ̊i[ϐ
var
	pApci8284GetVersion			:TApci8284GetVersion;
	pApci8284Create					:TApci8284Create;
	pApci8284Close					:TApci8284Close;
	pApci8284GetResource		:TApci8284GetResource;
	pApci8284GetLastError		:TApci8284GetLastError;

	pApci8284IoReadByte			:TApci8284IoReadByte;
	pApci8284IoReadWord			:TApci8284IoReadWord;
	pApci8284IoReadDWord		:TApci8284IoReadDWord;
	pApci8284IoWriteByte		:TApci8284IoWriteByte;
	pApci8284IoWriteWord		:TApci8284IoWriteWord;
	pApci8284IoWriteDWord		:TApci8284IoWriteDWord;
	pApci8284MemReadByte		:TApci8284MemReadByte;
	pApci8284MemReadWord		:TApci8284MemReadWord;
	pApci8284MemReadDWord		:TApci8284MemReadDWord;
	pApci8284MemWriteByte		:TApci8284MemWriteByte;
	pApci8284MemWriteWord		:TApci8284MemWriteWord;
	pApci8284MemWriteDWord	:TApci8284MemWriteDWord;

	pApci8284DmaAlloc				:TApci8284DmaAlloc;
	pApci8284DmaRead				:TApci8284DmaRead;
	pApci8284DmaWrite				:TApci8284DmaWrite;
	pApci8284DmaFree				:TApci8284DmaFree;

	function _Apci8284wGetDllExportFunc: Boolean; forward;

{$J-}

//===================================================================
//   	DLL۰(۰ގʹװƂ)
//   	
// ߂l  True
//				s False
//===================================================================
function Apci8284wDllOpen: Boolean;
begin
	Result:=False;
	if hDLL=0 then begin
		hDLL:=LoadLibrary(APCI8284_DLL_NAME);
		if hDLL<>0 then begin
			if _Apci8284wGetDllExportFunc=True then begin
      	Result:=True
			end else Apci8284wDllClose;	// DLL֐擾ɎŝDLLN[Y
		end;
	end;
end;
//===================================================================
//   	DLL۰(۰ގʹװƂ)
//   	
// ߂l  True
//				s False
//===================================================================
function Apci8284wDllClose: Boolean;
begin
	Result:=False;
	if hDLL<>0 then begin
		if True=FreeLibrary(hDLL) then begin
			hDLL:=0;
			Result:=True;
		end;
	end;
end;
//===================================================================
//   	DLL,Driver ̃o[W擾
//   	pdwDllVer				DLL o[Wԍi[̈
//        pdwDrvVer				DRV o[Wԍi[̈
// ߂l  True
//				s False
//===================================================================
function Apci8284wGetVersion( var pdwDllVer:DWORD; var pdwDrvVer:DWORD ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8284GetVersion(pdwDllVer, pdwDrvVer);
end;
//===================================================================
//   	foCXgp錾
//   	pwLogSlot				gpfoCXԍi[̈
// ߂l  True
//				s False
//===================================================================
function Apci8284wCreate( var pwLogSlot:WORD; hWnd:HWND; u_WMBase:UINT ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8284Create(pwLogSlot,hWnd,u_WMBase);
end;
//===================================================================
//   	foCXJ
//   	wLogSlot				foCX̘_Xbgԍ
// ߂l  True
//				s False
//===================================================================
function Apci8284wClose( wLogSlot:WORD ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8284Close(wLogSlot);
end;
//===================================================================
//   	\[X擾
//   	wLogSlot				foCX̘_Xbgԍ
//				pRes						\[Xi[̈
// ߂l  True
//				s False
//===================================================================
function Apci8284wGetResource( wLogSlot:WORD; pRes:PAPCI8284R ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8284GetResource(wLogSlot,pRes);
end;
//===================================================================
//   	G[擾
//   	wLogSlot				foCX̘_Xbgԍ
// ߂l G[
//===================================================================
function Apci8284wGetLastError( wLogSlot:WORD ):DWORD;
begin
	if hDLL=0 then Result:=APCI8284_ERR_WRAPDLL
	else Result:=pApci8284GetLastError(wLogSlot)
end;
//===================================================================
//   	I/O BYTE  ǂݍ
//   	wLogSlot				foCX̘_Xbgԍ
//				wRegion					\[Ẍ
//				wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
function Apci8284wIoReadByte( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; var pbData: BYTE):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8284IoReadByte(wLogSlot,wRegion,dwOffset,pbData);
end;
//===================================================================
//   	I/O WORD  ǂݍ
//   	wLogSlot				foCX̘_Xbgԍ
//				wRegion					\[Ẍ
//				wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
function Apci8284wIoReadWord( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; var pwData: WORD):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8284IoReadWord(wLogSlot,wRegion,dwOffset,pwData);
end;
//===================================================================
//   	I/O DWORD ǂݍ
//   	wLogSlot				foCX̘_Xbgԍ
//				wRegion					\[Ẍ
//				wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
function Apci8284wIoReadDWord( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; var pdwData: DWORD):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8284IoReadDWord(wLogSlot,wRegion,dwOffset,pdwData);
end;
//===================================================================
//   	I/O BYTE  
//   	wLogSlot				foCX̘_Xbgԍ
//				wRegion					\[Ẍ
//				wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
function Apci8284wIoWriteByte( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; bData: BYTE):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8284IoWriteByte(wLogSlot,wRegion,dwOffset,bData);
end;
//===================================================================
//   	I/O WORD  
//   	wLogSlot				foCX̘_Xbgԍ
//				wRegion					\[Ẍ
//				wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
function Apci8284wIoWriteWord( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; wData: WORD):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8284IoWriteWord(wLogSlot,wRegion,dwOffset,wData);
end;
//===================================================================
//   	I/O DWORD 
//   	wLogSlot				foCX̘_Xbgԍ
//				wRegion					\[Ẍ
//				wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
function Apci8284wIoWriteDWord( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; dwData: DWORD):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8284IoWriteDWord(wLogSlot,wRegion,dwOffset,dwData);
end;
//===================================================================
//   	Memory BYTE  ǂݍ
//   	wLogSlot				foCX̘_Xbgԍ
//				wRegion					\[Ẍ
//				wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
function Apci8284wMemReadByte( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; var pbData: BYTE):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8284MemReadByte(wLogSlot,wRegion,dwOffset,pbData);
end;
//===================================================================
//   	Memory WORD  ǂݍ
//   	wLogSlot				foCX̘_Xbgԍ
//				wRegion					\[Ẍ
//				wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
function Apci8284wMemReadWord( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; var pwData: WORD):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8284MemReadWord(wLogSlot,wRegion,dwOffset,pwData);
end;
//===================================================================
//   	Memory DWORD ǂݍ
//   	wLogSlot				foCX̘_Xbgԍ
//				wRegion					\[Ẍ
//				wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
function Apci8284wMemReadDWord( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; var pdwData: DWORD):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8284MemReadDWord(wLogSlot,wRegion,dwOffset,pdwData);
end;
//===================================================================
//   	Memory BYTE  
//   	wLogSlot				foCX̘_Xbgԍ
//				wRegion					\[Ẍ
//				wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
function Apci8284wMemWriteByte( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; bData: BYTE):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8284MemWriteByte(wLogSlot,wRegion,dwOffset,bData);
end;
//===================================================================
//   	Memory WORD  
//   	wLogSlot				foCX̘_Xbgԍ
//				wRegion					\[Ẍ
//				wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
function Apci8284wMemWriteWord( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; wData: WORD):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8284MemWriteWord(wLogSlot,wRegion,dwOffset,wData);
end;
//===================================================================
//   	Memory DWORD  
//   	wLogSlot				foCX̘_Xbgԍ
//				wRegion					\[Ẍ
//				wOffset					ItZbg
//
// ߂l  True
//				s False
//===================================================================
function Apci8284wMemWriteDWord( wLogSlot:WORD; wRegion:WORD; dwOffset:DWORD; dwData: DWORD):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8284MemWriteDWord(wLogSlot,wRegion,dwOffset,dwData);
end;
//===================================================================
//   	hCoɂcl`]obt@mۂ܂
//   	wLogSlot				foCX̘_Xbgԍ
//				dwMemSize				mۂTCYw
//				pdwAddress			mۂobt@̃AhXi[ϐ
//
// ߂l  True
//				s False
//===================================================================
function Apci8284wDmaAlloc( wLogSlot:WORD; dwMemSize:DWORD; var pdwAddress: DWORD):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8284DmaAlloc(wLogSlot,dwMemSize,pdwAddress);
end;
//===================================================================
//   	cl`]pobt@ǂݍ
//   	wLogSlot				foCX̘_Xbgԍ
//				dwOffset				ItZbgw肵܂
//				pbBuff			    ǂݍ񂾃f[^i[̈̃|C^
//        dwSize          ǂݍރf[^w肵܂
//
// ߂l  True
//				s False
//===================================================================
function Apci8284wDmaRead( wLogSlot:WORD; dwOffset:DWORD; var pbBuff:array of BYTE; dwSize: DWORD ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8284DmaRead(wLogSlot,dwOffset,PChar(@pbBuff),dwSize);
end;
//===================================================================
//   	cl`]pobt@
//   	wLogSlot				foCX̘_Xbgԍ
//				dwOffset				ItZbgw肵܂
//				pbBuff			    ރf[^i[Ă̈̃|C^
//        dwSize          ރf[^w肵܂
//
// ߂l  True
//				s False
//===================================================================
function Apci8284wDmaWrite( wLogSlot:WORD; dwOffset:DWORD; var pbBuff:array of BYTE; dwSize: DWORD ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8284DmaWrite(wLogSlot,dwOffset,PChar(@pbBuff),dwSize);
end;
//===================================================================
//   	cl`]obt@J
//   	wLogSlot				foCX̘_Xbgԍ
//
// ߂l  True
//				s False
//===================================================================
function Apci8284wDmaFree( wLogSlot:WORD ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8284DmaFree(wLogSlot);
end;
//-------------------------------------------------------------------
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  True
//		  	s False
//-------------------------------------------------------------------
function _Apci8284wGetDllExportFunc: Boolean;
begin
	Result:=False;

	pApci8284GetVersion			:=GetProcAddress(hDLL, 'Apci8284GetVersion');
	pApci8284Create					:=GetProcAddress(hDLL, 'Apci8284Create');
	pApci8284Close					:=GetProcAddress(hDLL, 'Apci8284Close');
	pApci8284GetResource		:=GetProcAddress(hDLL, 'Apci8284GetResource');
	pApci8284GetLastError		:=GetProcAddress(hDLL, 'Apci8284GetLastError');
	pApci8284IoReadByte			:=GetProcAddress(hDLL, 'Apci8284IoReadByte');
	pApci8284IoReadWord			:=GetProcAddress(hDLL, 'Apci8284IoReadWord');
	pApci8284IoReadDWord		:=GetProcAddress(hDLL, 'Apci8284IoReadDWord');
	pApci8284IoWriteByte		:=GetProcAddress(hDLL, 'Apci8284IoWriteByte');
	pApci8284IoWriteWord		:=GetProcAddress(hDLL, 'Apci8284IoWriteWord');
	pApci8284IoWriteDWord		:=GetProcAddress(hDLL, 'Apci8284IoWriteDWord');
	pApci8284MemReadByte		:=GetProcAddress(hDLL, 'Apci8284MemReadByte');
	pApci8284MemReadWord		:=GetProcAddress(hDLL, 'Apci8284MemReadWord');
	pApci8284MemReadDWord		:=GetProcAddress(hDLL, 'Apci8284MemReadDWord');
	pApci8284MemWriteByte		:=GetProcAddress(hDLL, 'Apci8284MemWriteByte');
	pApci8284MemWriteWord		:=GetProcAddress(hDLL, 'Apci8284MemWriteWord');
	pApci8284MemWriteDWord	:=GetProcAddress(hDLL, 'Apci8284MemWriteDWord');
	pApci8284DmaAlloc				:=GetProcAddress(hDLL, 'Apci8284DmaAlloc');
	pApci8284DmaRead				:=GetProcAddress(hDLL, 'Apci8284DmaRead');
	pApci8284DmaWrite				:=GetProcAddress(hDLL, 'Apci8284DmaWrite');
	pApci8284DmaFree				:=GetProcAddress(hDLL, 'Apci8284DmaFree');

	if @pApci8284GetVersion			= nil then Exit;
	if @pApci8284Create					= nil then Exit;
	if @pApci8284Close					= nil then Exit;
	if @pApci8284GetResource		= nil then Exit;
	if @pApci8284GetLastError		= nil then Exit;
	if @pApci8284IoReadByte			= nil then Exit;
	if @pApci8284IoReadWord			= nil then Exit;
	if @pApci8284IoReadDWord		= nil then Exit;
	if @pApci8284IoWriteByte		= nil then Exit;
	if @pApci8284IoWriteWord		= nil then Exit;
	if @pApci8284IoWriteDWord		= nil then Exit;
	if @pApci8284MemReadByte		= nil then Exit;
	if @pApci8284MemReadWord		= nil then Exit;
	if @pApci8284MemReadDWord		= nil then Exit;
	if @pApci8284MemWriteByte		= nil then Exit;
	if @pApci8284MemWriteWord		= nil then Exit;
	if @pApci8284MemWriteDWord	= nil then Exit;
	if @pApci8284DmaAlloc				= nil then Exit;
	if @pApci8284DmaRead				= nil then Exit;
	if @pApci8284DmaWrite				= nil then Exit;
	if @pApci8284DmaFree				= nil then Exit;

	// SĂ DLL ߰Ċ֐ڽ擾nj
	Result:=True;
end;

end.





