Attribute VB_Name = "Wrapper"
'====================================================================
' Apci8284w.bas - DLL Wrapper
'--------------------------------------------------------------------
' Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'====================================================================
Option Explicit

Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const APCI8284_DLL_NAME = "Apci8284.dll" ' DLĻٖ
Global Const APCI8284_ERR_WRAPDLL = -1          ' ׯ߰֐װ
Dim hDLL As Long                                ' DLL

'===================================================================
'       Apci8284.dll۰(۰ގʹװƂ)
'       
'  ߂l    True
'           s False
'===================================================================
Function Apci8284wDllOpen() As Boolean
  Apci8284wDllOpen = False
  If hDLL = 0 Then
    hDLL = LoadLibrary(APCI8284_DLL_NAME)
    If hDLL <> 0 Then
      Apci8284wDllOpen = Apci8284GetDllExportFunc()
      If Apci8284wDllOpen <> True Then
        Apci8284wDllClose     ' DLL֐擾ɎŝDLL۰
      End If
    End If
  End If
End Function
'===================================================================
'       Apci8284.dll۰(۰ގʹװƂ)
'       
'  ߂l    True
'           s False
'===================================================================
Function Apci8284wDllClose() As Boolean
  Apci8284wDllClose = False
  If hDLL <> 0 Then
    If FreeLibrary(hDLL) <> 0 Then
      hDLL = 0
      Apci8284wDllClose = True
    End If
  End If
End Function
'===================================================================
'          DLL,Driver ̃o[W擾
'          pdwDllVer           DLL o[Wԍi[̈
'              pdwDrvVer           DRV o[Wԍi[̈
' ߂l        TRUE
'              s FALSE
'===================================================================
Function Apci8284wGetVersion(ByRef pdwDllVersion As Long, ByRef pdwDrvVersion As Long) As Boolean
  Apci8284wGetVersion = False
  If hDLL <> 0 Then
    If Apci8284GetVersion(pdwDllVersion, pdwDrvVersion) <> 0 Then
      Apci8284wGetVersion = True
    End If
  End If
End Function
'===================================================================
'          foCXgp錾
'          pwLogSlot           gpfoCXԍi[̈
' ߂l        TRUE
'              s FALSE
'===================================================================
Function Apci8284wCreate(ByRef pwLogSlot As Integer, ByVal hWnd As Long, ByVal uWMBase As Long) As Boolean
  Apci8284wCreate = False
  If hDLL <> 0 Then
    If Apci8284Create(pwLogSlot, hWnd, uWMBase) <> 0 Then
      Apci8284wCreate = True
    End If
  End If
End Function
'===================================================================
'          foCXJ
'          wLogSlot            foCX̘_Xbgԍ
' ߂l        TRUE
'              s FALSE
'===================================================================
Function Apci8284wClose(ByVal wLogSlot As Integer) As Boolean
  Apci8284wClose = False
  If hDLL <> 0 Then
    If Apci8284Close(wLogSlot) <> 0 Then
      Apci8284wClose = True
    End If
  End If
End Function
'===================================================================
'          \[X擾
'          wLogSlot            foCX̘_Xbgԍ
'              pRes                \[Xi[̈
' ߂l        TRUE
'              s FALSE
'===================================================================
Function Apci8284wGetResource(ByVal wLogSlot As Integer, ByRef pRes As APCI8284RESOURCE) As Boolean
  Apci8284wGetResource = False
  If hDLL <> 0 Then
    If Apci8284GetResource(wLogSlot, pRes) <> 0 Then
      Apci8284wGetResource = True
    End If
  End If
End Function
'===================================================================
'          G[擾
'          wLogSlot            foCX̘_Xbgԍ
' ߂l       G[
'===================================================================
Function Apci8284wGetLastError(ByVal wLogSlot As Integer) As Long
  If hDLL = 0 Then
    Apci8284wGetLastError = APCI8284_ERR_WRAPDLL
  Else
    Apci8284wGetLastError = Apci8284GetLastError(wLogSlot)
  End If
End Function
'===================================================================
'      I/O BYTE  ǂݍ
'      wLogSlot                foCX̘_Xbgԍ
'          wRegion                 \[Ẍ
'          wOffset                 ItZbg
'
' ߂l  True
'              s False
'===================================================================
Function Apci8284wIoReadByte(ByVal wLogSlot As Integer, ByVal wRegion As Integer, ByVal dwOffset As Long, ByRef pbData As Byte) As Boolean
  Apci8284wIoReadByte = False
  If hDLL <> 0 Then
    If Apci8284IoReadByte(wLogSlot, wRegion, dwOffset, pbData) <> 0 Then
      Apci8284wIoReadByte = True
    End If
  End If
End Function
'===================================================================
'      I/O WORD  ǂݍ
'      wLogSlot                foCX̘_Xbgԍ
'          wRegion                 \[Ẍ
'          wOffset                 ItZbg
'
' ߂l  True
'              s False
'===================================================================
Function Apci8284wIoReadWord(ByVal wLogSlot As Integer, ByVal wRegion As Integer, ByVal dwOffset As Long, ByRef pwData As Integer) As Boolean
  Apci8284wIoReadWord = False
  If hDLL <> 0 Then
    If Apci8284IoReadWord(wLogSlot, wRegion, dwOffset, pwData) <> 0 Then
      Apci8284wIoReadWord = True
    End If
  End If
End Function
'===================================================================
'      I/O DWORD ǂݍ
'      wLogSlot                foCX̘_Xbgԍ
'          wRegion                 \[Ẍ
'          wOffset                 ItZbg
'
' ߂l  True
'              s False
'===================================================================
Function Apci8284wIoReadDWord(ByVal wLogSlot As Integer, ByVal wRegion As Integer, ByVal dwOffset As Long, ByRef pdwData As Long) As Boolean
  Apci8284wIoReadDWord = False
  If hDLL <> 0 Then
    If Apci8284IoReadDWord(wLogSlot, wRegion, dwOffset, pdwData) <> 0 Then
      Apci8284wIoReadDWord = True
    End If
  End If
End Function
'===================================================================
'      I/O BYTE  
'      wLogSlot                foCX̘_Xbgԍ
'          wRegion                 \[Ẍ
'          wOffset                 ItZbg
'
' ߂l  True
'              s False
'===================================================================
Function Apci8284wIoWriteByte(ByVal wLogSlot As Integer, ByVal wRegion As Integer, ByVal dwOffset As Long, ByVal bData As Byte) As Boolean
  Apci8284wIoWriteByte = False
  If hDLL <> 0 Then
    If Apci8284IoWriteByte(wLogSlot, wRegion, dwOffset, bData) <> 0 Then
      Apci8284wIoWriteByte = True
    End If
  End If
End Function
'===================================================================
'      I/O WORD  
'      wLogSlot                foCX̘_Xbgԍ
'          wRegion                 \[Ẍ
'          wOffset                 ItZbg
'
' ߂l  True
'              s False
'===================================================================
Function Apci8284wIoWriteWord(ByVal wLogSlot As Integer, ByVal wRegion As Integer, ByVal dwOffset As Long, ByVal wData As Integer) As Boolean
  Apci8284wIoWriteWord = False
  If hDLL <> 0 Then
    If Apci8284IoWriteWord(wLogSlot, wRegion, dwOffset, wData) <> 0 Then
      Apci8284wIoWriteWord = True
    End If
  End If
End Function
'===================================================================
'      I/O DWORD 
'      wLogSlot                foCX̘_Xbgԍ
'          wRegion                 \[Ẍ
'          wOffset                 ItZbg
'
' ߂l  True
'              s False
'===================================================================
Function Apci8284wIoWriteDWord(ByVal wLogSlot As Integer, ByVal wRegion As Integer, ByVal dwOffset As Long, ByVal dwData As Long) As Boolean
  Apci8284wIoWriteDWord = False
  If hDLL <> 0 Then
    If Apci8284IoWriteDWord(wLogSlot, wRegion, dwOffset, dwData) <> 0 Then
      Apci8284wIoWriteDWord = True
    End If
  End If
End Function
'===================================================================
'      Memory BYTE  ǂݍ
'      wLogSlot                foCX̘_Xbgԍ
'          wRegion                 \[Ẍ
'          wOffset                 ItZbg
'
' ߂l  True
'              s False
'===================================================================
Function Apci8284wMemReadByte(ByVal wLogSlot As Integer, ByVal wRegion As Integer, ByVal dwOffset As Long, ByRef pbData As Byte) As Boolean
  Apci8284wMemReadByte = False
  If hDLL <> 0 Then
    If Apci8284MemReadByte(wLogSlot, wRegion, dwOffset, pbData) <> 0 Then
      Apci8284wMemReadByte = True
    End If
  End If
End Function
'===================================================================
'      Memory WORD  ǂݍ
'      wLogSlot                foCX̘_Xbgԍ
'          wRegion                 \[Ẍ
'          wOffset                 ItZbg
'
' ߂l  True
'              s False
'===================================================================
Function Apci8284wMemReadWord(ByVal wLogSlot As Integer, ByVal wRegion As Integer, ByVal dwOffset As Long, ByRef pwData As Integer) As Boolean
  Apci8284wMemReadWord = False
  If hDLL <> 0 Then
    If Apci8284MemReadWord(wLogSlot, wRegion, dwOffset, pwData) <> 0 Then
      Apci8284wMemReadWord = True
    End If
  End If
End Function
'===================================================================
'      Memory DWORD ǂݍ
'      wLogSlot                foCX̘_Xbgԍ
'          wRegion                 \[Ẍ
'          wOffset                 ItZbg
'
' ߂l  True
'              s False
'===================================================================
Function Apci8284wMemReadDWord(ByVal wLogSlot As Integer, ByVal wRegion As Integer, ByVal dwOffset As Long, ByRef pdwData As Long) As Boolean
  Apci8284wMemReadDWord = False
  If hDLL <> 0 Then
    If Apci8284MemReadDWord(wLogSlot, wRegion, dwOffset, pdwData) <> 0 Then
      Apci8284wMemReadDWord = True
    End If
  End If
End Function
'===================================================================
'      Memory BYTE  
'      wLogSlot                foCX̘_Xbgԍ
'          wRegion                 \[Ẍ
'          wOffset                 ItZbg
'
' ߂l  True
'              s False
'===================================================================
Function Apci8284wMemWriteByte(ByVal wLogSlot As Integer, ByVal wRegion As Integer, ByVal dwOffset As Long, ByVal bData As Byte) As Boolean
  Apci8284wMemWriteByte = False
  If hDLL <> 0 Then
    If Apci8284MemWriteByte(wLogSlot, wRegion, dwOffset, bData) <> 0 Then
      Apci8284wMemWriteByte = True
    End If
  End If
End Function
'===================================================================
'      Memory WORD  
'      wLogSlot                foCX̘_Xbgԍ
'          wRegion                 \[Ẍ
'          wOffset                 ItZbg
'
' ߂l  True
'              s False
'===================================================================
Function Apci8284wMemWriteWord(ByVal wLogSlot As Integer, ByVal wRegion As Integer, ByVal dwOffset As Long, ByVal wData As Integer) As Boolean
  Apci8284wMemWriteWord = False
  If hDLL <> 0 Then
    If Apci8284MemWriteWord(wLogSlot, wRegion, dwOffset, wData) <> 0 Then
      Apci8284wMemWriteWord = True
    End If
  End If
End Function
'===================================================================
'      Memory DWORD  
'      wLogSlot                foCX̘_Xbgԍ
'          wRegion                 \[Ẍ
'          wOffset                 ItZbg
'
' ߂l  True
'              s False
'===================================================================
Function Apci8284wMemWriteDWord(ByVal wLogSlot As Integer, ByVal wRegion As Integer, ByVal dwOffset As Long, ByVal dwData As Long) As Boolean
  Apci8284wMemWriteDWord = False
  If hDLL <> 0 Then
    If Apci8284MemWriteDWord(wLogSlot, wRegion, dwOffset, dwData) <> 0 Then
      Apci8284wMemWriteDWord = True
    End If
  End If
End Function
'===================================================================
'      hCoɂcl`]obt@mۂ܂
'      wLogSlot                foCX̘_Xbgԍ
'          dwMemSize               mۂTCYw
'          pdwAddress              mۂobt@̃AhXi[ϐ
'
' ߂l  True
'              s False
'===================================================================
Function Apci8284wDmaAlloc(ByVal wLogSlot As Integer, ByVal dwMemSize As Long, ByRef pdwAddress As Long) As Boolean
  Apci8284wDmaAlloc = False
  If hDLL <> 0 Then
    If Apci8284DmaAlloc(wLogSlot, dwMemSize, pdwAddress) <> 0 Then
      Apci8284wDmaAlloc = True
    End If
  End If
End Function
'===================================================================
'      cl`]pobt@ǂݍ
'      wLogSlot                foCX̘_Xbgԍ
'          dwOffset                ItZbgw肵܂
'          pbBuff                  ǂݍ񂾃f[^i[̈̃|C^
'          dwSize                  ǂݍރf[^w肵܂
'
' ߂l  True
'        s False
'===================================================================
Function Apci8284wDmaRead(ByVal wLogSlot As Integer, ByVal dwOffset As Long, ByRef pbBuff() As Byte, ByVal dwSize As Long) As Boolean
  Apci8284wDmaRead = False
  If hDLL <> 0 Then
    If Apci8284DmaRead(wLogSlot, dwOffset, pbBuff(LBound(pbBuff)), dwSize) <> 0 Then
      Apci8284wDmaRead = True
    End If
  End If
End Function
'===================================================================
'      cl`]pobt@
'      wLogSlot                foCX̘_Xbgԍ
'          dwOffset                ItZbgw肵܂
'          pbBuff                  ރf[^i[Ă̈̃|C^
'          dwSize                  ރf[^w肵܂
'
' ߂l  True
'        s False
'===================================================================
Function Apci8284wDmaWrite(ByVal wLogSlot As Integer, ByVal dwOffset As Long, ByRef pbBuff() As Byte, ByVal dwSize As Long) As Boolean
  Apci8284wDmaWrite = False
  If hDLL <> 0 Then
    If Apci8284DmaWrite(wLogSlot, dwOffset, pbBuff(LBound(pbBuff)), dwSize) <> 0 Then
      Apci8284wDmaWrite = True
    End If
  End If
End Function
'===================================================================
'      cl`]obt@J
'      wLogSlot                foCX̘_Xbgԍ
'
' ߂l  True
'              s False
'===================================================================
Function Apci8284wDmaFree(ByVal wLogSlot As Integer) As Boolean
  Apci8284wDmaFree = False
  If hDLL <> 0 Then
    If Apci8284DmaFree(wLogSlot) <> 0 Then
      Apci8284wDmaFree = True
    End If
  End If
End Function
'--------------------------------------------------------------------
'       DLL߰Ċ֐ڽ̎擾
'       
'  ߂l    True
'           s False
'--------------------------------------------------------------------
Private Function Apci8284GetDllExportFunc() As Boolean
  Dim pFunc As Long

    Apci8284GetDllExportFunc = False

    pFunc = GetProcAddress(hDLL, "Apci8284GetVersion")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8284Create")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8284Close")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8284GetResource")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8284GetLastError")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8284IoReadByte")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8284IoReadWord")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8284IoReadDWord")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8284IoWriteByte")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8284IoWriteWord")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8284IoWriteDWord")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8284MemReadByte")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8284MemReadWord")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8284MemReadDWord")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8284MemWriteByte")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8284MemWriteWord")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8284MemWriteDWord")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8284DmaAlloc")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8284DmaRead")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8284DmaWrite")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8284DmaFree")
    If pFunc = 0 Then Exit Function

    Apci8284GetDllExportFunc = True

End Function











